import 'dart:io' show File;
import 'dart:async';

import 'package:build/build.dart';

import 'package:yaml/yaml.dart' show loadYaml;

Builder buildAppInfo([BuilderOptions? options]) =>
    // output is hardcoded in `build.yaml`
    _AppInfoBuilder(options!.config['output']);

class _AppInfoBuilder implements Builder {
  final String output;

  _AppInfoBuilder(this.output);

  @override
  Future build(BuildStep buildStep) async {
    final packageInfo = loadYaml(File('pubspec.yaml').readAsStringSync());

    await buildStep.writeAsString(buildStep.allowedOutputs.single, '''
// Generated code. Do not modify.

// Information about the package from pubspec
final packageName = '${packageInfo['name']}';
final packageVersion = '${packageInfo['version']}';
final packageDescription = '${packageInfo['description']}';

// git hash
final packageGitHash = 'foobar';
''');
  }

  @override
  Map<String, List<String>> get buildExtensions => {
        'pubspec.yaml': [output],
      };
}
